/*
    MiddleMan filtering proxy server
    Copyright (C) 2002  Jason McLaughlin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <string.h>
#include "proto.h"

extern GLOBAL *global;

void global_load(XML_LIST * xml_list)
{
	while ((xml_list = xml_section(xml_list, "<global>"))) {
		XML_LIST_LOOP(xml_list, "<global>") {
			XML_LIST_CMP(xml_list, "<general>") {
				XML_LIST_LOOP(xml_list, "<general>") {
					XML_LIST_CMP(xml_list, "<ctimeout>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_general_insert(xml_list->item, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<timeout>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_general_insert(NULL, xml_list->item, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<keeptimeout>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_general_insert(NULL, NULL, xml_list->item, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<maxbuffer>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_general_insert(NULL, NULL, NULL, xml_list->item, NULL, NULL, NULL, NULL, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<tempdir>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_general_insert(NULL, NULL, NULL, NULL, xml_list->item, NULL, NULL, NULL, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<linelength>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_general_insert(NULL, NULL, NULL, NULL, NULL, xml_list->item, NULL, NULL, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<cportrange>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_general_insert(NULL, NULL, NULL, NULL, NULL, NULL, xml_list->item, NULL, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<poolsize>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_general_insert(NULL, NULL, NULL, NULL, NULL, NULL, NULL, xml_list->item, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<pooltimeout>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_general_insert(NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, xml_list->item, NULL);
					}
					XML_LIST_CMP(xml_list, "<compressout>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE) {
							pthread_rwlock_wrlock(&global->general->lock);
							if (!strcasecmp(xml_list->item, "true"))
								global->general->compressout = TRUE;
							else
								global->general->compressout = FALSE;
							pthread_rwlock_unlock(&global->general->lock);
						}
					}
					XML_LIST_CMP(xml_list, "<compressin>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE) {
							pthread_rwlock_wrlock(&global->general->lock);
							if (!strcasecmp(xml_list->item, "true"))
								global->general->compressin = TRUE;
							else
								global->general->compressin = FALSE;
							pthread_rwlock_unlock(&global->general->lock);
						}
					}
					XML_LIST_CMP(xml_list, "<encodemime>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_general_insert(NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, xml_list->item);
					}
				}
			}
			XML_LIST_CMP(xml_list, "<ftp>") {
				XML_LIST_LOOP(xml_list, "<ftp>") {
					XML_LIST_CMP(xml_list, "<passive>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE) {
							pthread_rwlock_wrlock(&global->ftp->lock);
							if (!strcasecmp(xml_list->item, "true"))
								global->ftp->pasv = TRUE;
							else
								global->ftp->pasv = FALSE;
							pthread_rwlock_unlock(&global->ftp->lock);
						}
					}
					XML_LIST_CMP(xml_list, "<anonlogin>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_ftp_insert(xml_list->item, NULL, NULL, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<anonpass>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_ftp_insert(NULL, xml_list->item, NULL, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<timeout>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_ftp_insert(NULL, NULL, xml_list->item, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<sortorder>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_ftp_insert(NULL, NULL, NULL, xml_list->item, NULL);
					}
					XML_LIST_CMP(xml_list, "<sortfield>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_ftp_insert(NULL, NULL, NULL, NULL, xml_list->item);
					}
				}
			}
			XML_LIST_CMP(xml_list, "<dnsbl>") {
				XML_LIST_LOOP(xml_list, "<dnsbl>") {
					XML_LIST_CMP(xml_list, "<enabled>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE) {
							pthread_rwlock_rdlock(&global->dnsbl->lock);
							if (!strcasecmp(xml_list->item, "true"))
								global->dnsbl->enabled = TRUE;
							else
								global->dnsbl->enabled = FALSE;
							pthread_rwlock_unlock(&global->dnsbl->lock);
						}
					}
					XML_LIST_CMP(xml_list, "<template>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_dnsbl_insert(xml_list->item, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<domain>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_dnsbl_insert(NULL, xml_list->item, NULL);
					}
					XML_LIST_CMP(xml_list, "<badips>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_dnsbl_insert(NULL, NULL, xml_list->item);
					}
				}
			}
			XML_LIST_CMP(xml_list, "<prefetch>") {
				XML_LIST_LOOP(xml_list, "<prefetch>") {
					XML_LIST_CMP(xml_list, "<enabled>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE) {
							pthread_mutex_lock(&global->prefetch->lock);
							if (!strcasecmp(xml_list->item, "true"))
								global->prefetch->enabled = TRUE;
							else
								global->prefetch->enabled = FALSE;
							pthread_mutex_unlock(&global->prefetch->lock);
						}
					}
					XML_LIST_CMP(xml_list, "<threads>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_prefetch_insert(xml_list->item, NULL, NULL);
					}
					XML_LIST_CMP(xml_list, "<queuesize>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_prefetch_insert(NULL, xml_list->item, NULL);
					}
					XML_LIST_CMP(xml_list, "<tags>") {
						xml_list = xml_list->next;
						if (xml_list->type == XML_VALUE)
							global_prefetch_insert(NULL, NULL, xml_list->item);
					}
				}
			}
		}
	}

}

XML_LIST *global_xml(XML_LIST * xml_list)
{
	char buf[128], *ptr;

	xml_list = xml_list_add(xml_list, "<global>", XML_TAG);

	pthread_rwlock_rdlock(&global->general->lock);
	xml_list = xml_list_add(xml_list, "<general>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<ctimeout>", XML_TAG);
	snprintf(buf, sizeof(buf), "%d", global->general->ctimeout);
	xml_list = xml_list_add(xml_list, buf, XML_VALUE);
	xml_list = xml_list_add(xml_list, "</ctimeout>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<timeout>", XML_TAG);
	snprintf(buf, sizeof(buf), "%d", global->general->timeout);
	xml_list = xml_list_add(xml_list, buf, XML_VALUE);
	xml_list = xml_list_add(xml_list, "</timeout>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<keeptimeout>", XML_TAG);
	snprintf(buf, sizeof(buf), "%d", global->general->keeptimeout);
	xml_list = xml_list_add(xml_list, buf, XML_VALUE);
	xml_list = xml_list_add(xml_list, "</keeptimeout>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<maxbuffer>", XML_TAG);
	snprintf(buf, sizeof(buf), "%d", global->general->maxbuffer);
	xml_list = xml_list_add(xml_list, buf, XML_VALUE);
	xml_list = xml_list_add(xml_list, "</maxbuffer>", XML_TAG);

	if (global->general->tempdir != NULL) {
		xml_list = xml_list_add(xml_list, "<tempdir>", XML_TAG);
		ptr = string_to_xml(global->general->tempdir);
		xml_list = xml_list_add(xml_list, ptr, XML_VALUE);
		xfree(ptr);
		xml_list = xml_list_add(xml_list, "</tempdir>", XML_TAG);
	}

	xml_list = xml_list_add(xml_list, "<linelength>", XML_TAG);
	snprintf(buf, sizeof(buf), "%d", global->general->linelength);
	xml_list = xml_list_add(xml_list, buf, XML_VALUE);
	xml_list = xml_list_add(xml_list, "</linelength>", XML_TAG);

	if (global->general->cportrange != NULL) {
		xml_list = xml_list_add(xml_list, "<cportrange>", XML_TAG);
		ptr = string_to_xml(global->general->cportrange);
		xml_list = xml_list_add(xml_list, ptr, XML_VALUE);
		xfree(ptr);
		xml_list = xml_list_add(xml_list, "</cportrange>", XML_TAG);
	}

	xml_list = xml_list_add(xml_list, "<poolsize>", XML_TAG);
	snprintf(buf, sizeof(buf), "%d", global->general->poolsize);
	xml_list = xml_list_add(xml_list, buf, XML_VALUE);
	xml_list = xml_list_add(xml_list, "</poolsize>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<pooltimeout>", XML_TAG);
	snprintf(buf, sizeof(buf), "%d", global->general->pooltimeout);
	xml_list = xml_list_add(xml_list, buf, XML_VALUE);
	xml_list = xml_list_add(xml_list, "</pooltimeout>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<compressout>", XML_TAG);
	xml_list = xml_list_add(xml_list, (global->general->compressout == TRUE) ? "true" : "false", XML_VALUE);
	xml_list = xml_list_add(xml_list, "</compressout>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<compressin>", XML_TAG);
	xml_list = xml_list_add(xml_list, (global->general->compressin == TRUE) ? "true" : "false", XML_VALUE);
	xml_list = xml_list_add(xml_list, "</compressin>", XML_TAG);

	if (global->general->encodemime != NULL) {
		xml_list = xml_list_add(xml_list, "<encodemime>", XML_TAG);
		xml_list = xml_list_add(xml_list, global->general->encodemime, XML_VALUE);
		xml_list = xml_list_add(xml_list, "</encodemime>", XML_TAG);
	}

	xml_list = xml_list_add(xml_list, "</general>", XML_TAG);
	pthread_rwlock_unlock(&global->general->lock);

	pthread_rwlock_rdlock(&global->ftp->lock);
	xml_list = xml_list_add(xml_list, "<ftp>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<passive>", XML_TAG);
	xml_list = xml_list_add(xml_list, (global->ftp->pasv == TRUE) ? "true" : "false", XML_VALUE);
	xml_list = xml_list_add(xml_list, "</passive>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<timeout>", XML_TAG);
	snprintf(buf, sizeof(buf), "%d", global->ftp->timeout);
	xml_list = xml_list_add(xml_list, buf, XML_VALUE);
	xml_list = xml_list_add(xml_list, "</timeout>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<anonlogin>", XML_TAG);
	ptr = string_to_xml(global->ftp->anonlogin);
	xml_list = xml_list_add(xml_list, ptr, XML_VALUE);
	xfree(ptr);
	xml_list = xml_list_add(xml_list, "</anonlogin>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<anonpass>", XML_TAG);
	ptr = string_to_xml(global->ftp->anonpass);
	xml_list = xml_list_add(xml_list, ptr, XML_VALUE);
	xfree(ptr);
	xml_list = xml_list_add(xml_list, "</anonpass>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<sortorder>", XML_TAG);
	xml_list = xml_list_add(xml_list, (global->ftp->sortorder == SORT_DESCENDING) ? "descending" : "ascending", XML_VALUE);
	xml_list = xml_list_add(xml_list, "</sortorder>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<sortfield>", XML_TAG);
	xml_list = xml_list_add(xml_list, (global->ftp->sortfield == SORT_SIZE) ? "size" : (global->ftp->sortfield == SORT_DATE) ? "date" : (global->ftp->sortfield == SORT_NAME) ? "name" : "none", XML_VALUE);
	xml_list = xml_list_add(xml_list, "</sortfield>", XML_TAG);

	xml_list = xml_list_add(xml_list, "</ftp>", XML_TAG);
	pthread_rwlock_unlock(&global->ftp->lock);

	pthread_rwlock_rdlock(&global->dnsbl->lock);
	xml_list = xml_list_add(xml_list, "<dnsbl>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<enabled>", XML_TAG);
	xml_list = xml_list_add(xml_list, (global->dnsbl->enabled == TRUE) ? "true" : "false", XML_VALUE);
	xml_list = xml_list_add(xml_list, "</enabled>", XML_TAG);

	if (global->dnsbl->template != NULL) {
		xml_list = xml_list_add(xml_list, "<template>", XML_TAG);
		ptr = string_to_xml(global->dnsbl->template);
		xml_list = xml_list_add(xml_list, ptr, XML_VALUE);
		xfree(ptr);
		xml_list = xml_list_add(xml_list, "</template>", XML_TAG);
	}

	if (global->dnsbl->domain != NULL) {
		xml_list = xml_list_add(xml_list, "<domain>", XML_TAG);
		ptr = string_to_xml(global->dnsbl->domain);
		xml_list = xml_list_add(xml_list, ptr, XML_VALUE);
		xfree(ptr);
		xml_list = xml_list_add(xml_list, "</domain>", XML_TAG);
	}

	if (global->dnsbl->badips != NULL) {
		xml_list = xml_list_add(xml_list, "<badips>", XML_TAG);
		ptr = array_merge(global->dnsbl->badips, ',');
		xml_list = xml_list_add(xml_list, ptr, XML_VALUE);
		xfree(ptr);
		xml_list = xml_list_add(xml_list, "</badips>", XML_TAG);
	}

	xml_list = xml_list_add(xml_list, "</dnsbl>", XML_TAG);
	pthread_rwlock_unlock(&global->dnsbl->lock);

	pthread_mutex_lock(&global->prefetch->lock);
	xml_list = xml_list_add(xml_list, "<prefetch>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<enabled>", XML_TAG);
	xml_list = xml_list_add(xml_list, (global->prefetch->enabled == TRUE) ? "true" : "false", XML_VALUE);
	xml_list = xml_list_add(xml_list, "</enabled>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<threads>", XML_TAG);
	snprintf(buf, sizeof(buf), "%d", global->prefetch->threads);
	xml_list = xml_list_add(xml_list, buf, XML_VALUE);
	xml_list = xml_list_add(xml_list, "</threads>", XML_TAG);

	xml_list = xml_list_add(xml_list, "<queuesize>", XML_TAG);
	snprintf(buf, sizeof(buf), "%d", global->prefetch->queuesize);
	xml_list = xml_list_add(xml_list, buf, XML_VALUE);
	xml_list = xml_list_add(xml_list, "</queuesize>", XML_TAG);

	if (global->prefetch->tags != NULL) {
		xml_list = xml_list_add(xml_list, "<tags>", XML_TAG);
		ptr = array_merge(global->prefetch->tags, ',');
		xml_list = xml_list_add(xml_list, ptr, XML_VALUE);
		xfree(ptr);
		xml_list = xml_list_add(xml_list, "</tags>", XML_TAG);
	}

	xml_list = xml_list_add(xml_list, "</prefetch>", XML_TAG);
	pthread_mutex_unlock(&global->prefetch->lock);

	xml_list = xml_list_add(xml_list, "</global>", XML_TAG);

	return xml_list;
}

void global_general_insert(char *ctimeout, char *timeout, char *keeptimeout, char *maxbuffer, char *tempdir, char *linelength, char *cportrange, char *poolsize, char *pooltimeout, char *encodemime)
{
	pthread_rwlock_wrlock(&global->general->lock);

	if (ctimeout != NULL) {
		global->general->ctimeout = 0;

		if (strcmp(ctimeout, ""))
			global->general->ctimeout = atoi(ctimeout);
	}

	if (timeout != NULL) {
		global->general->timeout = 0;

		if (strcmp(timeout, ""))
			global->general->timeout = atoi(timeout);
	}

	if (keeptimeout != NULL) {
		global->general->keeptimeout = 0;

		if (strcmp(keeptimeout, ""))
			global->general->keeptimeout = atoi(keeptimeout);
	}

	if (maxbuffer != NULL) {
		global->general->maxbuffer = 0;

		if (strcmp(maxbuffer, ""))
			global->general->maxbuffer = string_to_size(maxbuffer);
	}

	if (tempdir != NULL) {
		FREE_AND_NULL(global->general->tempdir);

		if (strcmp(tempdir, ""))
			global->general->tempdir = xstrdup(tempdir);
	}

	if (linelength != NULL) {
		global->general->linelength = 0;

		if (strcmp(linelength, ""))
			global->general->linelength = atoi(linelength);
	}

	if (cportrange != NULL) {
		FREE_AND_NULL(global->general->cportrange);

		if (strcmp(cportrange, ""))
			global->general->cportrange = xstrdup(cportrange);
	}

	if (poolsize != NULL) {
		global->general->poolsize = POOL_SIZE;

		if (strcmp(poolsize, ""))
			global->general->poolsize = atoi(poolsize);
	}

	if (pooltimeout != NULL) {
		global->general->pooltimeout = POOL_TIMEOUT;

		if (strcmp(pooltimeout, ""))
			global->general->pooltimeout = atoi(pooltimeout);
	}

	if (encodemime != NULL) {
		FREE_AND_NULL(global->general->encodemime);
		if (global->general->emp != NULL)
			reg_free(global->general->emp);

		if (strcmp(encodemime, "")) {
			global->general->encodemime = xstrdup(encodemime);
			global->general->emp = reg_compile(encodemime, REGFLAGS);
		} else
			global->general->emp = NULL;
	}

	pthread_rwlock_unlock(&global->general->lock);
}

void global_ftp_insert(char *anonlogin, char *anonpass, char *timeout, char *sortorder, char *sortfield)
{
	pthread_rwlock_wrlock(&global->ftp->lock);
	if (anonlogin != NULL) {
		FREE_AND_NULL(global->ftp->anonlogin);

		if (strcmp(anonlogin, ""))
			global->ftp->anonlogin = xstrdup(anonlogin);
		else
			global->ftp->anonlogin = xstrdup(ANONLOGIN);
	}

	if (anonpass != NULL) {
		FREE_AND_NULL(global->ftp->anonpass);

		if (strcmp(anonpass, ""))
			global->ftp->anonpass = xstrdup(anonpass);
		else
			global->ftp->anonpass = xstrdup(ANONPASS);
	}

	if (timeout != NULL) {
		global->ftp->timeout = 15;

		if (strcmp(timeout, ""))
			global->ftp->timeout = atoi(timeout);
	}

	if (sortorder != NULL) {
		global->ftp->sortorder = SORT_ASCENDING;

		if (strcmp(sortorder, "")) {
			if (!strcasecmp(sortorder, "descending"))
				global->ftp->sortorder = SORT_DESCENDING;
			else
				global->ftp->sortorder = SORT_ASCENDING;
		}
	}

	if (sortfield != NULL) {
		global->ftp->sortfield = SORT_NAME;

		if (strcmp(sortfield, "")) {
			if (!strcasecmp(sortfield, "size"))
				global->ftp->sortfield = SORT_SIZE;
			else if (!strcasecmp(sortfield, "date"))
				global->ftp->sortfield = SORT_DATE;
			else if (!strcasecmp(sortfield, "name"))
				global->ftp->sortfield = SORT_NAME;
			else
				global->ftp->sortfield = SORT_NONE;
		}
	}

	pthread_rwlock_unlock(&global->ftp->lock);
}

void global_dnsbl_insert(char *template, char *domain, char *badips)
{
	pthread_rwlock_wrlock(&global->dnsbl->lock);

	if (template != NULL) {
		FREE_AND_NULL(global->dnsbl->template);

		if (strcmp(template, ""))
			global->dnsbl->template = xstrdup(template);
	}

	if (domain != NULL) {
		FREE_AND_NULL(global->dnsbl->domain);

		if (strcmp(domain, ""))
			global->dnsbl->domain = xstrdup(domain);
	}

	if (badips != NULL) {
		if (global->dnsbl->badips != NULL)
			array_free(global->dnsbl->badips);

		if (strcmp(badips, ""))
			global->dnsbl->badips = string_break(badips, ',');
		else
			global->dnsbl->badips = NULL;
	}

	pthread_rwlock_unlock(&global->dnsbl->lock);
}

void global_prefetch_insert(char *threads, char *queuesize, char *tags)
{
	pthread_mutex_lock(&global->prefetch->lock);
	if (threads != NULL) {
		global->prefetch->threads = 0;

		if (strcmp(threads, ""))
			global->prefetch->threads = atoi(threads);
	}

	if (queuesize != NULL) {
		global->prefetch->queuesize = 0;

		if (strcmp(queuesize, ""))
			global->prefetch->queuesize = atoi(queuesize);
	}

	if (tags != NULL) {
		if (global->prefetch->tags != NULL)
			array_free(global->prefetch->tags);

		if (strcmp(tags, ""))
			global->prefetch->tags = string_break(tags, ',');
		else
		global->prefetch->tags = NULL;
	}

	pthread_mutex_unlock(&global->prefetch->lock);
}
