/*
    MiddleMan filtering proxy server
    Copyright (C) 2002  Jason McLaughlin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <stdlib.h>
#include "proto.h"

/*
basic checking for malloc/realloc/free, better to die gracefully than run into problems
later on.
*/

void *xmalloc(int size)
{
	void *ret;

	ASSERT(size > 0);

	ret = malloc(size);

	ASSERT(ret);

	return ret;
}

void xfree(void *ptr)
{
	ASSERT(ptr);

	free(ptr);
}

void *xrealloc(void *ptr, int newsize)
{
	void *newptr;

	ASSERT(newsize > 0);

	newptr = realloc(ptr, newsize);

	ASSERT(newptr);

	return newptr;
}
